#
# Conditional build:
%bcond_without	doc		# don't rebuild documentation

Summary:	C compiler for Intel 8051 and Zilog Z80
Summary(pl.UTF-8):	Kompilator C dla Intel 8051 i Zilog Z80
Name:		sdcc
Version:	3.3.0
Release:	1
License:	GPL
Group:		Development/Languages
Source0:	http://downloads.sourceforge.net/sdcc/%{name}-src-%{version}.tar.bz2
# Source0-md5:	c7c6aa75415580795ecc4fd31948e5ba
Patch0:		%{name}-mcs51-pcall.patch
Patch1:		%{name}-mcs51-stack-probe.patch
Patch2:		%{name}-gstabs.patch
URL:		http://sdcc.sourceforge.net/
BuildRequires:	autoconf
BuildRequires:	bison
BuildRequires:	boost-devel
BuildRequires:	flex
BuildRequires:	gc-devel
BuildRequires:	gputils
BuildRequires:	libstdc++-devel
%if %{with doc}
BuildRequires:	latex2html
BuildRequires:	lyx >= 1.4.4
BuildRequires:	texlive-fonts-cmsuper
BuildRequires:	texlive-fonts-type1-urw
BuildRequires:	texlive-format-pdflatex
BuildRequires:	texlive-latex-ams
BuildRequires:	texlive-makeindex
BuildRequires:	texlive-tex-babel
BuildRequires:	texlive-xetex
%endif
Obsoletes:	ucsim
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define         _noautostrip    .*%{_datadir}/%{name}/.*

%description
SDCC is retargettable, optimizing ANSI - C compiler. The current
version targets the Intel 8051 and recently the Zilog Z80 based MCUs.
SDCC can be retargeted for other 8 bit MCUs or PICs and some day soon
will be. Supported data types are short (8 bits, 1 byte), char (8
bits, 1 byte) , int (16 bits, 2 bytes ), long (32 bit, 4 bytes) and
float (4 byte IEEE). SDCC also comes with the source level debugger
SDCDB.

%description -l pl.UTF-8
SDCC jest kompilatorem ANSI C. Aktualna wersja wspiera procesory Intel
8051 oraz Zilog Z80. SDCC może być łatwo zmodyfikowany by wspierać
inne 8 bitowe jednostki. Wspierane typy danych to short (8 bitów, 1
bajt), char (8 bitów, 1 bajt), int (16 bitów, 2 bajty), long (32 bity,
4 bajty) oraz float (4 bajty IEEE). SDCC dostarcza również debugger
oparty na emulatorze ucsim.

%prep
%setup -q
#%%patch0 -p1
#%%patch1 -p1
#%%patch2 -p1

%build
#find -type f -name 'configure.??' | while read FILE; do
#	cd $(dirname "$FILE")
#	%{__autoconf}
#	cd -
#done

%configure \
	PDFOPT=/bin/cp \
	%{__enable_disable doc} \
	--enable-libgc \
	--enable-ucsim \
	--enable-xa \
	--enable-serio \
	--enable-statistic

%{__make} -j1

cd device/lib
%{__make} -j1 model-mcs51-stack-auto
%{__make} -j1 model-mcs51-xstack-auto
cd -

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_libdir}/emacs/site-lisp

%{__make} install \
	"DESTDIR=$RPM_BUILD_ROOT" \
	"docdir=%{_docdir}/%{name}-%{version}" \
	"STRIP=/bin/true"

# some cleanups in mess generated by make install
#find $RPM_BUILD_ROOT -name "CVS" -type d | xargs rm -r
#mv $RPM_BUILD_ROOT%{_bindir}/*.el $RPM_BUILD_ROOT%{_libdir}/emacs/site-lisp

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc %{_docdir}/%{name}-%{version}
%attr(755,root,root) %{_bindir}/*
%{_datadir}/%{name}
#%{_libdir}/emacs/site-lisp/*.el
%changelog
* Fri Dec 06 2013 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/sdcc.git;a=log;h=master

* Thu Dec 05 2013 Jan Rękorajski <baggins@pld-linux.org> 76352ee
- pdfopt is long dead and gone, fool  configure with cp

* Sun Jul 21 2013 Witold Filipczyk <witekfl@poczta.onet.pl> edea816
- up to 3.3.0

* Sun Mar 24 2013 witekfl <witekfl@poczta.onet.pl> 100f1d1
- snapshot 20130324; commented old patches; BR: texlive-xetex

* Tue Aug 03 2010 kosmo <kosmo@pld-linux.org> cc5ed3e
- updated to snap 20100803

* Mon Jun 21 2010 kosmo <kosmo@pld-linux.org> 8fa97a0
- updated to snap 20100614

* Tue Feb 02 2010 sparky <sparky@pld-linux.org> ad45c64
- added without doc bcond
- readded as-build patch
- dropped BR: automake

* Tue Feb 02 2010 sparky <sparky@pld-linux.org> 7e515d8
- readded, with directory names updated

* Tue Feb 02 2010 kosmo <kosmo@pld-linux.org> d3d5e2d
- outdated, removed.

* Tue Feb 02 2010 kosmo <kosmo@pld-linux.org> e2899b4
- updated to 2.9.7 (snap 20100201).

* Wed Nov 11 2009 kosmo <kosmo@pld-linux.org> 20adacc
- updated to 2.9.4 (snap 20091108)
- fixed build on SMP machines.

* Tue Jun 16 2009 kosmo <kosmo@pld-linux.org> ecf6960
- updated BRs,
- fixed build on SMP machines.

* Tue Jun 09 2009 kosmo <kosmo@pld-linux.org> 4befaf8
- updated to 2.9.1 (snap 20090609).

* Sun Mar 15 2009 kosmo <kosmo@pld-linux.org> 1ed556a
- updated to 2.9.0 (snap 20090314)

* Tue Feb 24 2009 Arkadiusz Miśkiewicz <arekm@maven.pl> 8e93683
- rel .5

* Thu Nov 06 2008 kosmo <kosmo@pld-linux.org> 30c720f
- allow function call via pointer on MCS51
- rel 4

* Thu Nov 06 2008 kosmo <kosmo@pld-linux.org> c72b486
- allow function call via pointer on MCS51

* Sun Nov 02 2008 wrobell <wrobell@pld-linux.org> 21a15d8
- include PIC library support (thanks to gputils)
- rel. 3

* Sun Nov 02 2008 wrobell <wrobell@pld-linux.org> a6034cd
- rel. 2

* Sun Nov 02 2008 wrobell <wrobell@pld-linux.org> d67fff5
- apply the 2nd patch

* Sun Nov 02 2008 wrobell <wrobell@pld-linux.org> 2911930
- fixed debug build

